// 3 argomenti: esame stringa comando [parametro]
// il processo iniziale crea un processo figlio
// il process figlio, una volta avviato, esegue il comando passato come secondo parametro
// il padre attende la terminazione del figlio, quindi visualizza la stringa passata come
// primo parametro (e finalmente termina)
// AGGIUNTA: il figlio esegue il comando, eventualmente con un parametro 
// (TERZO ARGOMENTO OPZIONALE) 
// 
#include <stdio.h>

char *stringa, *comando, *parametro;

main(int argc, char*argv[]) {
	int i, pid;
	printf("argc: %i\n", argc);
	for(i=0;i<argc;i++)
		printf("argv[%d]: %s\n", i, argv[i]);
	if( argc<3 ) exit( 0 );
	stringa = argv[1];
	comando = argv[2];
	if( argc==4 ) 
		parametro = argv[3];

	pid=fork();
	printf("pid vale %d\n", pid);
	if( pid==0 ) { //codice figlio
		printf("Sono il figlio, il mio PID e' %d\n", getpid());
		if( argc==3 ) 
			execl(comando,comando,NULL);
		else // argc>3
			execl(comando,comando,parametro,NULL);
		perror("Errore nell'esecuzione del comando passato come parametro");
		exit(-1);
	}
	else { //codice padre
		int pid_terminato, status;
		printf("Sono il padre, il mio PID e' %d\n", getpid());
		pid_terminato = wait( &status );
		if( pid_terminato==pid )
			printf( "Il figlio e' terminato con stato %d\n", status );
		else
			printf( "Non stampero' mai questa riga\n" );
		printf( "Primo parametro: %s\n", stringa );
		exit( 0 );
	}
	printf("Terminato processo %s, PID %d\n", pid==0? "figlio":"padre", getpid());
}
