// sintassi: copia nomefile1 nomefile2
// nomefile1 deve esistere gia'
// nomefile2 non deve esistere gia'
#include <fcntl.h>
#include <stdio.h>

char *nomefile1, *nomefile2;

main(int argc, char *argv[]) {
	int pid, fd1, fd2;
	char buf[10];
	
	if( argc!=3 ) exit( -1 );
	nomefile1=argv[1];
	nomefile2=argv[2];
	if( (fd1=open(nomefile1,O_RDONLY))<0 ) {
		// nomefile1 non esiste
		perror( "Il primo parametro non rappresenta un file esistente" );
		exit( -2 );
	}
	if( (fd2=open(nomefile2,O_WRONLY))>0 ) {
		// nomefile1 non esiste
		perror( "Il secondo parametro rappresenta un file gia' esistente" );
		close( fd1 );
		exit( -3 );
	}
	else {
		// creo nomefile2
		fd2=creat(nomefile2,0644);
		if(fd2<0) {
			// errore nella creazione del file
			perror( "Non sono riuscito a creare il file" );
			exit( -3 );
		}
		// creo il figlio
		pid=fork();
		if( pid==0 ) { // codice figlio
			int n;
			do {
				n=read( fd1, buf, 10 );
				write( fd2, buf, n );
			} while( n==10 );
			printf( "Figlio: ho terminato di copiare %s in %s\n", nomefile1, nomefile2 );
			close( fd1 );
			close( fd2 );
		}
		else { // codice padre
			int status;
			close( fd1 );
			close( fd2 );
			
			wait( &status );
			if( status==0 ) {
				// figlio terminato correttamente
				int n;
				
				fd2=open( nomefile2, O_RDONLY );
				
				if( fd2<0 ) exit( -5 );
				do {
					n=read( fd2, buf, 10 );
					write( 1, buf, n );
				} while( n==10 );
				printf( "Padre: %s terminato\n", nomefile2 );
				close( fd2 );
			}
			else {
				// errore nel figlio
				exit( -4 );
			}
		}
	}	
}
