// esame c1 c2 file
// c1 e c2 caratteri, c1 < c2
// P0 crea 3 figli
// P0 passa c1 a P1
// P1 scrive c1 su file e passa il successore di c1 a P2
// etc (P1->P2, P2->P3, P3->P1, ...)
// quando un figlio riceve c2, deve terminare e tutti devono terminare.
//
#include <stdio.h>
#include <fcntl.h>

main( int argc, char *argv[] ) {
	int pid1, pid2, pid3;
	int p1[2], p2[2], p3[2];
	int i, fd, status;
	char c, car1, car2, *file;

	if( argc<4 ) exit( -1 );
	car1=argv[1][0];
	car2=argv[2][0];
	file=argv[3];
	if(( car1<'a' )||( car1>'z' )) exit( -2 );
	if(( car2<'a' )||( car2>'z' )) exit( -3 );
	if( car2<car1 ) exit( -4 );
	if( (fd=open( file, O_WRONLY ))>0 ) exit( -5 );

	printf( "Controllo parametri completato\n" );
	
	fd=creat( file, 0644 );
	if( fd<0 ) exit( -6 );

	pipe( p1 );
	pipe( p2 );
	pipe( p3 );

	printf( "Pipe create\n" );
	
	pid1=fork();
	if( pid1<0 ) exit( -7 );
	if( pid1==0 ) {
		// primo figlio
		close( p2[0] );
		close( p1[1] );
		close( p3[0] );
		close( p3[1] );
	
		while( read( p1[0], &c, 1 ) ) {
			printf( "Primo figlio: letto il carattere %c\n", c );
			if( c<car2 ) {
				write( fd, &c, 1 );
				c++;
				write( p2[1], &c, 1 );
			}
			else break;
		}
		close( p2[1] );
		close( fd );
		printf( "Primo figlio termina\n" );
		exit( 0 );
	}

	printf( "Primo figlio creato\n" );

	pid2=fork();
	if( pid2<0 ) exit( -7 );
	if( pid2==0 ) {
		// secondo figlio
		close( p3[0] );
		close( p2[1] );
		close( p1[0] );
		close( p1[1] );
	
		while( read( p2[0], &c, 1 ) ) {
			printf( "Secondo figlio: letto il carattere %c\n", c );
			if( c<car2 ) {
				write( fd, &c, 1 );
				c++;
				write( p3[1], &c, 1 );
			}
			else break;
		}
		close( p3[1] );
		close( p2[0] );
		close( fd );
		printf( "Secondo figlio termina\n" );
		exit( 0 );
	}
	printf( "Secondo figlio creato\n" );

	pid3=fork();
	if( pid3<0 ) exit( -7 );
	if( pid3==0 ) {
		// terzo figlio
		close( p1[0] );
		close( p3[1] );
		close( p2[0] );
		close( p2[1] );
	
		while( read( p3[0], &c, 1 ) ) {
			printf( "Terzo figlio: letto il carattere %c\n", c );
			if( c<car2 ) {
				write( fd, &c, 1 );
				c++;
				write( p1[1], &c, 1 );
			}
			else break;
		}
		close( p1[1] );
		close( p3[0] );
		close( fd );
		printf( "Terzo figlio termina\n" );
		exit( 0 );
	}
	
	printf( "Terzo figlio creato\n" );
	
	// padre
	
	write( p1[1], &car1, 1 );
	close( p1[0] );
	close( p1[1] );
	close( p2[0] );
	close( p2[1] );
	close( p3[0] );
	close( p3[1] );
	close( fd );

	for(i=0;i<3;i++) wait( &status );
	printf( "Comando terminato\n" );

	fd=open( file, O_RDONLY );
	while( read( fd, &c, 1 ) )
		write( 1, &c, 1 );
}
